## mingw-w64-gnuradio-3.10.12.0-2.src.tar.zst

=== gr-fft/CMakeLists.txt ===
# Copyright 2012 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Setup dependencies
########################################################################
include(GrBoost)

find_package(FFTW3f)

########################################################################
# Register component
########################################################################
include(GrComponent)

gr_register_component("gr-fft" ENABLE_GR_FFT Boost_FOUND ENABLE_GNURADIO_RUNTIME
                      ENABLE_GR_BLOCKS FFTW3f_FOUND)

########################################################################
# Begin conditional configuration
########################################################################
if(ENABLE_GR_FFT)

    ########################################################################
    # Add subdirectories
    ########################################################################
    add_subdirectory(include/gnuradio/fft)
    add_subdirectory(lib)
    if(ENABLE_PYTHON)
        add_subdirectory(python/fft)
    endif(ENABLE_PYTHON)
    if(ENABLE_GRC)
        add_subdirectory(grc)
    endif(ENABLE_GRC)
    add_subdirectory(docs)

    ########################################################################
    # Create Pkg Config File
    ########################################################################
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/gnuradio-fft.pc.in
                   ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-fft.pc @ONLY)

    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-fft.pc
            DESTINATION ${GR_LIBRARY_DIR}/pkgconfig)

endif(ENABLE_GR_FFT)

=== docs/doxygen/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Create the doxygen configuration file
########################################################################
file(TO_NATIVE_PATH ${PROJECT_SOURCE_DIR} top_srcdir)
file(TO_NATIVE_PATH ${PROJECT_BINARY_DIR} top_builddir)
file(TO_NATIVE_PATH ${PROJECT_SOURCE_DIR} abs_top_srcdir)
file(TO_NATIVE_PATH ${PROJECT_BINARY_DIR} abs_top_builddir)

set(HAVE_DOT ${DOXYGEN_DOT_FOUND})
set(enable_html_docs YES)
set(enable_latex_docs NO)
set(enable_xml_docs YES)

if(MATHJAX2_FOUND)
    set(enable_mathjax YES)
else()
    message(WARNING "MathJax 2 not found, HTML equations might not be properly rendered.")
    set(enable_mathjax NO)
endif()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
               ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/other/build_guide.dox.in
               ${CMAKE_CURRENT_BINARY_DIR}/other/build_guide.dox @ONLY)

set(BUILT_DIRS ${CMAKE_CURRENT_BINARY_DIR}/xml ${CMAKE_CURRENT_BINARY_DIR}/html)

########################################################################
# Make and install doxygen docs
########################################################################
add_custom_command(
    OUTPUT ${BUILT_DIRS}
    COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS ${GENERATED_DEPS}
    COMMENT "Generating documentation with doxygen")

add_custom_target(doxygen_target ALL DEPENDS ${BUILT_DIRS})

if(ENABLE_DOXYGEN)
    add_custom_command(
        OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/gnuradio_docstrings.json
        COMMAND
            ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/docs/doxygen/update_pydoc.py
            "scrape" "--xml_path" ${PROJECT_BINARY_DIR}/docs/doxygen/xml "--json_path"
            ${CMAKE_CURRENT_BINARY_DIR}/gnuradio_docstrings.json
        COMMENT "Scraping generated documentation for docstrings ..."
        DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/update_pydoc.py doxygen_target)

    add_custom_target(gnuradio_docstrings ALL
                      DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/gnuradio_docstrings.json)
endif(ENABLE_DOXYGEN)

install(DIRECTORY ${BUILT_DIRS} DESTINATION ${GR_PKG_DOC_DIR})

=== gr-filter/lib/CMakeLists.txt ===
# Copyright (C) 2012-2014,2017-2019,2020 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Setup library
########################################################################
add_library(
    gnuradio-filter
    fir_filter.cc
    fir_filter_blk_impl.cc
    fir_filter_with_buffer.cc
    fft_filter.cc
    firdes.cc
    freq_xlating_fir_filter_impl.cc
    ival_decimator_impl.cc
    iir_filter.cc
    interp_fir_filter_impl.cc
    mmse_fir_interpolator_cc.cc
    mmse_fir_interpolator_ff.cc
    mmse_interp_differentiator_cc.cc
    mmse_interp_differentiator_ff.cc
    pm_remez.cc
    polyphase_filterbank.cc
    dc_blocker_cc_impl.cc
    dc_blocker_ff_impl.cc
    filter_delay_fc_impl.cc
    filterbank.cc
    filterbank_vcvcf_impl.cc
    fft_filter_ccc_impl.cc
    fft_filter_ccf_impl.cc
    fft_filter_fff_impl.cc
    mmse_resampler_cc_impl.cc
    mmse_resampler_ff_impl.cc
    hilbert_fc_impl.cc
    iir_filter_ffd_impl.cc
    iir_filter_ccc_impl.cc
    iir_filter_ccf_impl.cc
    iir_filter_ccd_impl.cc
    iir_filter_ccz_impl.cc
    pfb_arb_resampler.cc
    pfb_arb_resampler_ccf_impl.cc
    pfb_arb_resampler_ccc_impl.cc
    pfb_arb_resampler_fff_impl.cc
    pfb_channelizer_ccf_impl.cc
    pfb_decimator_ccf_impl.cc
    pfb_interpolator_ccf_impl.cc
    pfb_synthesizer_ccf_impl.cc
    rational_resampler_impl.cc
    single_pole_iir_filter_cc_impl.cc
    single_pole_iir_filter_ff_impl.cc)

target_link_libraries(
    gnuradio-filter
    PUBLIC gnuradio-runtime gnuradio-fft Volk::volk
    PRIVATE gnuradio-blocks)

if(ENABLE_COMMON_PCH)
    target_link_libraries(gnuradio-filter PRIVATE common-precompiled-headers)
endif()

target_include_directories(
    gnuradio-filter PUBLIC $<INSTALL_INTERFACE:include>
                           $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>)

#Add Windows DLL resource file if using MSVC
if(MSVC)
    include(${PROJECT_SOURCE_DIR}/cmake/Modules/GrVersion.cmake)

    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/gnuradio-filter.rc.in
                   ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-filter.rc @ONLY)

    target_sources(gnuradio-filter PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-filter.rc)
endif(MSVC)

gr_library_foo(gnuradio-filter)

########################################################################
# QA C++ Code for gr-filter
########################################################################
if(ENABLE_TESTING)
    include(GrTest)

    list(
        APPEND
        test_gr_filter_sources
        qa_firdes.cc
        qa_fir_filter_with_buffer.cc
        qa_mmse_fir_interpolator_cc.cc
        qa_mmse_fir_interpolator_ff.cc
        qa_mmse_interp_differentiator_cc.cc
        qa_mmse_interp_differentiator_ff.cc)
    list(APPEND GR_TEST_TARGET_DEPS gnuradio-filter gnuradio-fft)

    foreach(qa_file ${test_gr_filter_sources})
        gr_add_cpp_test("filter_${qa_file}" ${CMAKE_CURRENT_SOURCE_DIR}/${qa_file})
    endforeach(qa_file)
endif(ENABLE_TESTING)

=== gr-qtgui/lib/CMakeLists.txt ===
# Copyright 2010-2011,2013,2018 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Setup the QT file generations stuff
########################################################################

set(QTGUI_SOURCES
    DisplayPlot.cc
    FrequencyDisplayPlot.cc
    EyeDisplayPlot.cc
    TimeDomainDisplayPlot.cc
    TimeRasterDisplayPlot.cc
    timeRasterGlobalData.cc
    WaterfallDisplayPlot.cc
    waterfallGlobalData.cc
    ConstellationDisplayPlot.cc
    HistogramDisplayPlot.cc
    VectorDisplayPlot.cc
    spectrumdisplayform.cc
    displayform.cc
    eyedisplaysform.cc
    eyedisplayform.cc
    eyecontrolpanel.cc
    timedisplayform.cc
    timecontrolpanel.cc
    timerasterdisplayform.cc
    freqdisplayform.cc
    freqcontrolpanel.cc
    constellationdisplayform.cc
    histogramdisplayform.cc
    numberdisplayform.cc
    waterfalldisplayform.cc
    SpectrumGUIClass.cc
    spectrumUpdateEvents.cc
    plot_waterfall.cc
    plot_raster.cc
    sink_c_impl.cc
    sink_f_impl.cc
    eye_sink_c_impl.cc
    eye_sink_f_impl.cc
    time_sink_c_impl.cc
    time_sink_f_impl.cc
    time_raster_sink_b_impl.cc
    time_raster_sink_f_impl.cc
    freq_sink_c_impl.cc
    freq_sink_f_impl.cc
    const_sink_c_impl.cc
    waterfall_sink_c_impl.cc
    waterfall_sink_f_impl.cc
    histogram_sink_f_impl.cc
    number_sink_impl.cc
    qtgui_util.cc
    ber_sink_b_impl.cc
    vectordisplayform.cc
    vector_sink_f_impl.cc
    edit_box_msg_impl.cc
)

set(QTGUI_LIBS
    gnuradio-runtime
    gnuradio-fft
    gnuradio-filter
    Volk::volk
    qwt::qwt
    Qt5::Widgets
)

if(ENABLE_COMMON_PCH)
    set(PRIVATE_LIBS common-precompiled-headers)
endif()


add_library(
    gnuradio-qtgui
    ${QTGUI_SOURCES}
)

# Set up QWT library linkage:
target_compile_definitions(gnuradio-qtgui PRIVATE -DQWT_DLL)
target_include_directories(
    gnuradio-qtgui
    PUBLIC $<INSTALL_INTERFACE:include>
           $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>
    PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
target_link_libraries(gnuradio-qtgui
    PUBLIC ${QTGUI_LIBS}
    PRIVATE ${PRIVATE_LIBS}
)

set(qtgui_mod_includedir ${CMAKE_CURRENT_SOURCE_DIR}/../include/gnuradio/qtgui)
qt5_wrap_cpp(
    qtgui_moc_sources
    ${qtgui_mod_includedir}/spectrumdisplayform.h
    ${qtgui_mod_includedir}/displayform.h
    ${qtgui_mod_includedir}/eyedisplaysform.h
    ${qtgui_mod_includedir}/eyedisplayform.h
    ${qtgui_mod_includedir}/timedisplayform.h
    ${qtgui_mod_includedir}/eyecontrolpanel.h
    ${qtgui_mod_includedir}/timecontrolpanel.h
    ${qtgui_mod_includedir}/timerasterdisplayform.h
    ${qtgui_mod_includedir}/freqdisplayform.h
    ${qtgui_mod_includedir}/freqcontrolpanel.h
    ${qtgui_mod_includedir}/constellationdisplayform.h
    ${qtgui_mod_includedir}/waterfalldisplayform.h
    ${qtgui_mod_includedir}/histogramdisplayform.h
    ${qtgui_mod_includedir}/numberdisplayform.h
    ${qtgui_mod_includedir}/vectordisplayform.h
    ${qtgui_mod_includedir}/form_menus.h
    ${qtgui_mod_includedir}/DisplayPlot.h
    ${qtgui_mod_includedir}/EyeDisplayPlot.h
    ${qtgui_mod_includedir}/FrequencyDisplayPlot.h
    ${qtgui_mod_includedir}/TimeDomainDisplayPlot.h
    ${qtgui_mod_includedir}/TimeRasterDisplayPlot.h
    ${qtgui_mod_includedir}/WaterfallDisplayPlot.h
    ${qtgui_mod_includedir}/ConstellationDisplayPlot.h
    ${qtgui_mod_includedir}/HistogramDisplayPlot.h
    ${qtgui_mod_includedir}/VectorDisplayPlot.h
    edit_box_msg_impl.h)
target_sources(gnuradio-qtgui PRIVATE ${qtgui_moc_sources})
qt5_wrap_ui(qtgui_ui_hdrs spectrumdisplayform.ui)
target_sources(gnuradio-qtgui PRIVATE ${qtgui_ui_hdrs})

#FIXME the sources expect <foo>.ui.h, but the macros generate ui_foo.h
#avoid changing the sources by generating the header with the include
set(spectrum_ui_hdr ${CMAKE_CURRENT_BINARY_DIR}/spectrumdisplayform.ui.h)
if(NOT EXISTS ${spectrum_ui_hdr})
    file(WRITE ${spectrum_ui_hdr} "#include <ui_spectrumdisplayform.h>\n")
endif()

#Add Windows DLL resource file if using MSVC
if(MSVC)
    include(${PROJECT_SOURCE_DIR}/cmake/Modules/GrVersion.cmake)

    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/gnuradio-qtgui.rc.in
                   ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-qtgui.rc @ONLY)

    target_sources(gnuradio-qtgui PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-qtgui.rc)
endif(MSVC)

if(BUILD_SHARED_LIBS)
    gr_library_foo(gnuradio-qtgui Qwt Qt5Widgets)
endif()

=== gnuradio-runtime/include/gnuradio/CMakeLists.txt ===
# Copyright 2013 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

add_subdirectory(messages)
add_subdirectory(thread)

# Create a version.h with the project version
configure_file(version.h.in
               version.h)
# Install version.h in include/gnuradio
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/version.h
        DESTINATION ${GR_INCLUDE_DIR}/gnuradio)
########################################################################
# Install header files
########################################################################
install(
    FILES api.h
          attributes.h
          basic_block.h
          block.h
          block_detail.h
          block_registry.h
          buffer.h
          buffer_double_mapped.h
          buffer_reader.h
          buffer_reader_sm.h
          buffer_single_mapped.h
          buffer_type.h
          constants.h
          custom_lock.h
          dictionary_logger_backend.h
          endianness.h
          expj.h
          flowgraph.h
          fxpt.h
          fxpt_nco.h
          fxpt_vco.h
          gr_complex.h
          hier_block2.h
          high_res_timer.h
          host_buffer.h
          io_signature.h
          logger.h
          math.h
          message.h
          msg_accepter.h
          msg_handler.h
          msg_queue.h
          nco.h
          pmt_fmt.h
          pdu.h
          prefs.h
          pycallback_object.h
          random.h
          realtime.h
          runtime_types.h
          tags.h
          tagged_stream_block.h
          top_block.h
          tpb_detail.h
          transfer_type.h
          sincos.h
          sptr_magic.h
          sync_block.h
          sync_decimator.h
          sync_interpolator.h
          sys_paths.h
          types.h
          rpccallbackregister_base.h
          rpcmanager_base.h
          rpcmanager.h
          rpcregisterhelpers.h
          rpcserver_aggregator.h
          rpcserver_base.h
          rpcserver_booter_aggregator.h
          rpcserver_booter_base.h
          rpcserver_selector.h
          xoroshiro128p.h
    DESTINATION ${GR_INCLUDE_DIR}/gnuradio)

if(ENABLE_CTRLPORT_THRIFT)
    install(FILES rpcserver_booter_thrift.h thrift_application_base.h
                  thrift_server_template.h DESTINATION ${GR_INCLUDE_DIR}/gnuradio)


endif(ENABLE_CTRLPORT_THRIFT)

=== gr-fec/include/gnuradio/fec/CMakeLists.txt ===
# Copyright 2012,2014 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Install header files
########################################################################
install(
    FILES api.h
          generic_decoder.h
          generic_encoder.h
          decoder.h
          encoder.h
          tagged_decoder.h
          tagged_encoder.h
          async_decoder.h
          async_encoder.h
          cc_common.h
          cc_decoder.h
          cc_encoder.h
          ccsds_encoder.h
          dummy_encoder.h
          dummy_decoder.h
          repetition_encoder.h
          repetition_decoder.h
          decode_ccsds_27_fb.h
          encode_ccsds_27_bb.h
          rs.h
          viterbi.h
          ber_bf.h
          conv_bit_corr_bb.h
          puncture_bb.h
          puncture_ff.h
          depuncture_bb.h
          cldpc.h
          alist.h
          gf2mat.h
          gf2vec.h
          awgn_bp.h
          ldpc_encoder.h
          ldpc_decoder.h
          polar_encoder.h
          polar_decoder_sc.h
          polar_common.h
          polar_decoder_sc_list.h
          polar_decoder_common.h
          polar_encoder_systematic.h
          polar_decoder_sc_systematic.h
          maxstar.h
          tpc_common.h
          tpc_decoder.h
          tpc_encoder.h
    DESTINATION ${GR_INCLUDE_DIR}/gnuradio/fec)

if(GSL_FOUND)
    install(FILES fec_mtrx.h ldpc_H_matrix.h ldpc_G_matrix.h ldpc_bit_flip_decoder.h
                  ldpc_par_mtrx_encoder.h ldpc_gen_mtrx_encoder.h
            DESTINATION ${GR_INCLUDE_DIR}/gnuradio/fec)
endif(GSL_FOUND)

=== PKGBUILD ===
# Maintainer: Chris Gorman <chrisjohgorman@gmail.com>

_realname=gnuradio
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=3.10.12.0
pkgrel=2
pkgdesc="General purpose DSP and SDR toolkit (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://gnuradio.org/'
msys2_repository_url="https://github.com/gnuradio/gnuradio"
msys2_references=(
  'archlinux: gnuradio'
)
license=(spdx:GPL-3.0-or-later)
depends=("${MINGW_PACKAGE_PREFIX}-codec2"
  "${MINGW_PACKAGE_PREFIX}-boost-libs"
  "${MINGW_PACKAGE_PREFIX}-gcc-libs"
  "${MINGW_PACKAGE_PREFIX}-gmp"
  "${MINGW_PACKAGE_PREFIX}-gsl"
  "${MINGW_PACKAGE_PREFIX}-gsm"
  "${MINGW_PACKAGE_PREFIX}-gtk3"
  "${MINGW_PACKAGE_PREFIX}-libad9361-iio"
  "${MINGW_PACKAGE_PREFIX}-libiio"
  "${MINGW_PACKAGE_PREFIX}-libuhd" 
  "${MINGW_PACKAGE_PREFIX}-libunwind"
  "${MINGW_PACKAGE_PREFIX}-fftw"
  "${MINGW_PACKAGE_PREFIX}-mathjax2"
  "${MINGW_PACKAGE_PREFIX}-volk"
  "${MINGW_PACKAGE_PREFIX}-python-click"
  "${MINGW_PACKAGE_PREFIX}-python-click-plugins"
  "${MINGW_PACKAGE_PREFIX}-python-gobject"
  "${MINGW_PACKAGE_PREFIX}-python-cairo"
  "${MINGW_PACKAGE_PREFIX}-python-jsonschema"
  "${MINGW_PACKAGE_PREFIX}-python-mako"
  "${MINGW_PACKAGE_PREFIX}-python-matplotlib"
  "${MINGW_PACKAGE_PREFIX}-python-numpy"
  "${MINGW_PACKAGE_PREFIX}-python-pygccxml"
  "${MINGW_PACKAGE_PREFIX}-python-pyaml" 
  "${MINGW_PACKAGE_PREFIX}-python-pyzmq"
  "${MINGW_PACKAGE_PREFIX}-python-scipy"
  "${MINGW_PACKAGE_PREFIX}-python-qtpy"
  "${MINGW_PACKAGE_PREFIX}-python-pyqt5"
  "${MINGW_PACKAGE_PREFIX}-python-pyqtgraph"
  "${MINGW_PACKAGE_PREFIX}-python-lxml"
  "${MINGW_PACKAGE_PREFIX}-python-pyopengl"
  "${MINGW_PACKAGE_PREFIX}-qt5-base"
  "${MINGW_PACKAGE_PREFIX}-angleproject"
  "${MINGW_PACKAGE_PREFIX}-qwt-qt5"
  "${MINGW_PACKAGE_PREFIX}-SDL"
  "${MINGW_PACKAGE_PREFIX}-soapysdr"
  "${MINGW_PACKAGE_PREFIX}-portaudio"
  "${MINGW_PACKAGE_PREFIX}-libsndfile"
  "${MINGW_PACKAGE_PREFIX}-spdlog"
  "${MINGW_PACKAGE_PREFIX}-fmt"
  "${MINGW_PACKAGE_PREFIX}-zeromq")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-boost"
             "${MINGW_PACKAGE_PREFIX}-cppzmq"
             "${MINGW_PACKAGE_PREFIX}-doxygen"
             "${MINGW_PACKAGE_PREFIX}-pybind11"
             "${MINGW_PACKAGE_PREFIX}-python-packaging"
             "${MINGW_PACKAGE_PREFIX}-python-pip")
checkdepends=("${MINGW_PACKAGE_PREFIX}-python-setuptools"
              "${MINGW_PACKAGE_PREFIX}-python-pytest")
optdepends=("${MINGW_PACKAGE_PREFIX}-soapyrtlsdr: install to use RTL-SDR devices with gnuradio")
options=('!strip')
source=("https://github.com/${_realname}/${_realname}/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        "https://github.com/gnuradio/gnuradio/releases/download/v${pkgver}/${_realname}-${pkgver}.tar.gz.asc"
        0001-cmake-Install-python-wrapper-exe-for-scripts-on-Wind.patch
        gnuradio-blocks-and-examples-path.hook.in
        gnuradio-blocks-and-examples-path.script.in
        LICENSE.txt)
validpgpkeys=(
  'B90DDFAC56989BF62262EB812987C77CBB8ED9B2'  # GNU Radio Project (Admin) <admin@gnuradio.org>
  'D74F9F146E7F755783583158B343B2BA293E5174'  # Marcus Müller (GNU Radio Maintainer) <mmueller@gnuradio.org>
  '723EC3A2B90533C6B93DFBC8ED797743F7951435'  # GNU Radio (Software Signing Key) <info@gnuradio.org>
)
sha256sums=('fe78ad9f74c8ebf93d5c8ad6fa2c13236af330f3c67149d91a0647b3dc6f3958'
            'SKIP'
            'aa9c79f6ab923c566f57d90117fa7e82549c26230538ffb3a2b1c0246fc31c19'
            'b2f014a69b32afcb207e4d2e8e163fc04968594d7d4c3184b9ea5c8cf2a29329'
            'caa9a6cc253d508abcd01545f26b46df0d708d24f69b7dc59183d631872721ed'
            '86dc4bc79c9fa4d5dc3ae5558441d5bb8b8736403e70997cf9ae8f671ab5d0ca')
 
prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"

  # Patch number 0001 is credited to Ryan Volz <ryan.volz@gmail.com> and licensed under the 
  # BSD-3-Clause license
  patch -Np1 -i "${srcdir}/0001-cmake-Install-python-wrapper-exe-for-scripts-on-Wind.patch"
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  # FIXME remove -DENABLE_CTRLPORT_THRIFT=OFF when issue 7390 is fixed
  # https://github.com/gnuradio/gnuradio/issues/7390

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${_extra_config[@]}" \
      -DBoost_ATOMIC_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_atomic-mt.dll" \
      -DBoost_CHRONO_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_chrono-mt.dll" \
      -DBoost_DATE_TIME_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_date_time-mt.dll" \
      -DBoost_PROGRAM_OPTIONS_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_program_options-mt.dll" \
      -DBoost_THREAD_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_thread-mt.dll" \
      -DBoost_UNIT_TEST_FRAMEWORK_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_unit_test_framework-mt.dll" \
      -DENABLE_CTRLPORT_THRIFT=OFF \
      -S "${_realname}-${pkgver}" \
      -DMATHJAX2_JS_PATH="${MINGW_PREFIX}/share/mathjax2" \
      -B "build-${MSYSTEM}"

  "${MINGW_PREFIX}"/bin/cmake.exe --build "build-${MSYSTEM}"
}

check() {
  cd "${srcdir}/build-${MSYSTEM}"

  #copy all dlls to a directory
  if [ ! -d temp_lib ]; then
    mkdir temp_lib
    find . -name "*.dll" ! -path '*temp_lib*' -exec cp {} temp_lib \;
  fi

  #add a call to os.add_dll_directory() to load python dlls
  python_dll_prefix=`cygpath.exe -m -a .`
  python_dll_suffix="/gnuradio-runtime/python/gnuradio/gr/bindings"

  #run the sed regex
  find . -name "*_test.bat" -exec sed.exe -i 's|^\(.*python3.exe\)|\1 -c "import os; os.add_dll_directory('\'${python_dll_prefix}${python_dll_suffix}\'');"|g' {} \;

  #run tests with dll directory added to the path
  PATH=$PWD/temp_lib:$PATH \
    "${MINGW_PREFIX}"/bin/ctest.exe --timeout 90 --output-on-failure || warning "Tests failed"
}

package() {

  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install "build-${MSYSTEM}"

  #install hook and script for setting global_blocks_path and examples_path in grc.conf
  hook_path="${srcdir}"/${MINGW_PACKAGE_PREFIX}-gnuradio-blocks-and-examples-path.hook
  cp "${srcdir}/gnuradio-blocks-and-examples-path.hook.in" "${hook_path}"
  sed -s "s|@MINGW_PACKAGE_PREFIX@|${MINGW_PACKAGE_PREFIX}|g" -i "${hook_path}"
  install -Dt "$pkgdir/usr/share/libalpm/hooks" -m644 "${hook_path}"

  script_path="${srcdir}/${MINGW_PACKAGE_PREFIX}-gnuradio-blocks-and-examples-path.script";
  cp "${srcdir}/gnuradio-blocks-and-examples-path.script.in" "${script_path}"
  sed -s "s|@MINGW_PREFIX@|${MINGW_PREFIX}|g" -i "${script_path}"
  install -Dt "$pkgdir/usr/share/libalpm/scripts" -m755 "${script_path}"
 
  #install licenses
  install -Dm644 "${srcdir}/${_realname}-${pkgver}/COPYING" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/COPYING"
  install -Dm644 "${srcdir}/LICENSE.txt" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE.txt"
}
